import { ObservableQuery, WatchQueryOptions, QueryManager, QueryListener } from './QueryManager';
export declare class QueryScheduler {
    inFlightQueries: {
        [queryId: string]: WatchQueryOptions;
    };
    private queryManager;
    private pollingTimers;
    constructor({queryManager}: {
        queryManager: QueryManager;
    });
    checkInFlight(queryId: string): boolean;
    fetchQuery(queryId: string, options: WatchQueryOptions): Promise<{}>;
    startPollingQuery(options: WatchQueryOptions, listener: QueryListener, queryId?: string): string;
    stopPollingQuery(queryId: string): void;
    registerPollingQuery(options: WatchQueryOptions): ObservableQuery;
    private addInFlight(queryId, options);
    private removeInFlight(queryId);
}
